(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     17360,        526]
NotebookOptionsPosition[     16721,        503]
NotebookOutlinePosition[     17080,        519]
CellTagsIndexPosition[     17037,        516]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Three", " ", "simple", " ", "ways", " ", "to", " ", "treat", " ", 
   "systems", " ", "of", " ", "ordinary", " ", "differential", " ", 
   "equations"}], " ", "*)"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.475393768923597*^9, 3.475393785225466*^9}, {
  3.475399630508697*^9, 3.475399659967534*^9}},
 FontSize->18,
 Background->RGBColor[0.3333333333333333, 0., 0.4980392156862745]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
    "Euler", " ", "integration", " ", "of", " ", "harmonic", " ", 
     "oscillator"}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"euler", "[", 
      RowBox[{"x_", ",", "h_"}], "]"}], " ", ":=", " ", 
     RowBox[{"N", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "[", 
          RowBox[{"[", "1", "]"}], "]"}], " ", "+", " ", 
         RowBox[{"h", " ", 
          RowBox[{"x", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], ",", " ", 
        RowBox[{
         RowBox[{"x", "[", 
          RowBox[{"[", "2", "]"}], "]"}], " ", "-", 
         RowBox[{"h", " ", 
          RowBox[{"x", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}]}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ene", "[", "x_", "]"}], " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "n", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"n", "=", 
         RowBox[{"Length", "[", "x", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"x", "[", 
           RowBox[{"[", 
            RowBox[{"n", ",", "1"}], "]"}], "]"}], "^", "2"}], " ", "+", " ", 
         
         RowBox[{
          RowBox[{"x", "[", 
           RowBox[{"[", 
            RowBox[{"n", ",", "2"}], "]"}], "]"}], "^", "2"}], "-", "1"}]}]}],
       "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"integ", "[", 
     RowBox[{"x_", ",", "nstep_"}], "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"pos", ",", "h"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"h", "=", 
        RowBox[{"N", "[", 
         RowBox[{"2", " ", 
          RowBox[{"Pi", "/", "nstep"}]}], "]"}]}], ";", " ", 
       RowBox[{"pos", "=", "x"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", " ", 
        RowBox[{
         RowBox[{"pos", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"pos", ",", 
            RowBox[{"euler", "[", 
             RowBox[{
              RowBox[{"pos", "[", 
               RowBox[{"[", 
                RowBox[{"Length", "[", "pos", "]"}], "]"}], "]"}], ",", "h"}],
              "]"}]}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"2", " ", "nstep"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "pos"}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posa", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "10"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posb", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "20"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posc", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "50"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posd", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "100"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"posd", ",", "posc", ",", "posb", ",", "posa"}], "}"}], ",", 
     RowBox[{"PlotJoined", " ", "\[Rule]", " ", "True"}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "4"}], ",", "4"}], "}"}]}], "}"}]}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"a", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Pi", "/", "10"}]}], ",", 
         RowBox[{"ene", "[", "posa", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Pi", "/", "20"}]}], ",", 
         RowBox[{"ene", "[", "posb", "]"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Pi", "/", "50"}]}], ",", 
         RowBox[{"ene", "[", "posc", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Pi", "/", "100"}]}], ",", 
         RowBox[{"ene", "[", "posd", "]"}]}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Log", "[", "a", "]"}], ",", " ", 
     RowBox[{"PlotJoined", " ", "\[Rule]", " ", "True"}]}], 
    "]"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.466130061073457*^9, 3.466130286782436*^9}, {
   3.466130417105678*^9, 3.466130421119554*^9}, 3.466130564100601*^9, {
   3.46613071995171*^9, 3.466130720016617*^9}, {3.466130804984582*^9, 
   3.466130868193953*^9}, {3.466131043322857*^9, 3.466131177276626*^9}, {
   3.466131207887935*^9, 3.466131248114768*^9}, {3.466131292951478*^9, 
   3.466131312664145*^9}, {3.466239277800718*^9, 3.466239317945557*^9}, {
   3.46623940213452*^9, 3.466239573561203*^9}, {3.466327535933406*^9, 
   3.466327593692262*^9}, 3.475399659967581*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
    "Implicit", " ", "Euler", " ", "integration", " ", "of", " ", "harmonic", 
     " ", "oscillator"}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"impliciteuler", "[", 
      RowBox[{"x_", ",", "h_"}], "]"}], " ", ":=", " ", 
     RowBox[{"N", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"x", "[", 
            RowBox[{"[", "1", "]"}], "]"}], " ", "+", " ", 
           RowBox[{"h", " ", 
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"h", "^", "2"}]}], ")"}]}], ",", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"x", "[", 
            RowBox[{"[", "2", "]"}], "]"}], " ", "-", 
           RowBox[{"h", " ", 
            RowBox[{"x", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"h", "^", "2"}]}], ")"}]}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"integ", "[", 
     RowBox[{"x_", ",", "nstep_"}], "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"pos", ",", "h"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"h", "=", 
        RowBox[{"N", "[", 
         RowBox[{"2", " ", 
          RowBox[{"Pi", "/", "nstep"}]}], "]"}]}], ";", " ", 
       RowBox[{"pos", "=", "x"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", " ", 
        RowBox[{
         RowBox[{"pos", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"pos", ",", 
            RowBox[{"impliciteuler", "[", 
             RowBox[{
              RowBox[{"pos", "[", 
               RowBox[{"[", 
                RowBox[{"Length", "[", "pos", "]"}], "]"}], "]"}], ",", "h"}],
              "]"}]}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"2", " ", "nstep"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "pos"}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posa", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "10"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posb", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "20"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posc", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "50"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posd", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "100"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"posd", ",", "posc", ",", "posb", ",", "posa"}], "}"}], ",", 
     RowBox[{"PlotJoined", " ", "\[Rule]", " ", "True"}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"a", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Pi", "/", "10"}]}], ",", 
        RowBox[{"ene", "[", "posa", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Pi", "/", "20"}]}], ",", 
        RowBox[{"ene", "[", "posb", "]"}]}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Pi", "/", "50"}]}], ",", 
        RowBox[{"ene", "[", "posc", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Pi", "/", "100"}]}], ",", 
        RowBox[{"ene", "[", "posd", "]"}]}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"Abs", "[", "a", "]"}], "]"}], ",", " ", 
     RowBox[{"PlotJoined", " ", "\[Rule]", " ", "True"}]}], 
    "]"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.466132720366081*^9, 3.466132771042192*^9}, {
   3.466239324282334*^9, 3.466239346378454*^9}, {3.466327617763579*^9, 
   3.466327658641118*^9}, {3.475393695540648*^9, 3.475393696679928*^9}, 
   3.475399659967613*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{"Leap", "-", 
     RowBox[{
     "frog", " ", "integration", " ", "of", " ", "harmonic", " ", 
      "oscillator"}]}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"leapfrog", "[", 
      RowBox[{"x_", ",", "h_"}], "]"}], " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xx", ",", "yy"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"xx", "=", 
         RowBox[{
          RowBox[{"x", "[", 
           RowBox[{"[", "1", "]"}], "]"}], " ", "+", " ", 
          RowBox[{"h", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], " ", "-", " ", 
             RowBox[{"h", " ", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "/", "2"}]}]}], ")"}]}]}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"yy", " ", "=", " ", 
         RowBox[{
          RowBox[{"x", "[", 
           RowBox[{"[", "2", "]"}], "]"}], " ", "-", 
          RowBox[{"h", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "1", "]"}], "]"}], " ", "+", " ", "xx"}], ")"}], 
            "/", "2"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"xx", ",", "yy"}], "}"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"integ", "[", 
     RowBox[{"x_", ",", "nstep_"}], "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"pos", ",", "h"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"h", "=", 
        RowBox[{"N", "[", 
         RowBox[{"2", " ", 
          RowBox[{"Pi", "/", "nstep"}]}], "]"}]}], ";", " ", 
       RowBox[{"pos", "=", "x"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", " ", 
        RowBox[{
         RowBox[{"pos", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"pos", ",", 
            RowBox[{"leapfrog", "[", 
             RowBox[{
              RowBox[{"pos", "[", 
               RowBox[{"[", 
                RowBox[{"Length", "[", "pos", "]"}], "]"}], "]"}], ",", "h"}],
              "]"}]}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"2", " ", "nstep"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "pos"}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posa", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "10"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posb", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "20"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posc", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "50"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"posd", "=", 
     RowBox[{"integ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "100"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"posd", ",", "posc", ",", "posb", ",", "posa"}], "}"}], ",", 
     RowBox[{"PlotJoined", " ", "\[Rule]", " ", "True"}], ",", " ", 
     RowBox[{"PlotRange", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"a", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Pi", "/", "10"}]}], ",", 
        RowBox[{"ene", "[", "posa", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Pi", "/", "20"}]}], ",", 
        RowBox[{"ene", "[", "posb", "]"}]}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Pi", "/", "50"}]}], ",", 
        RowBox[{"ene", "[", "posc", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Pi", "/", "100"}]}], ",", 
        RowBox[{"ene", "[", "posd", "]"}]}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"Abs", "[", "a", "]"}], "]"}], ",", " ", 
     RowBox[{"PlotJoined", " ", "\[Rule]", " ", "True"}]}], 
    "]"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.466228525953364*^9, 3.466228652629353*^9}, {
   3.466239357627473*^9, 3.466239382390177*^9}, {3.466327683052129*^9, 
   3.466327683706634*^9}, 3.475399659967646*^9}]
}, Closed]]
},
WindowSize->{640, 573},
WindowMargins->{{112, Automatic}, {Automatic, 80}},
ShowSelection->True,
FrontEndVersion->"7.0 for Linux x86 (32-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[568, 22, 475, 10, 86, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[1046, 34, 5553, 161, 407, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[6602, 197, 4915, 147, 429, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[11520, 346, 5185, 154, 429, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Closed]]
}
]
*)

(* End of internal cache information *)
