(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     14359,        371]
NotebookOptionsPosition[     13721,        348]
NotebookOutlinePosition[     14078,        364]
CellTagsIndexPosition[     14035,        361]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"(*", "\[IndentingNewLine]", " ", 
  RowBox[{
   RowBox[{
   "van", " ", "der", " ", "Monde", " ", "matrices", " ", "can", " ", "have", 
    " ", "very", " ", "small", " ", 
    RowBox[{"determinants", ".", " ", "Here"}], " ", "we", " ", "investigate",
     " ", "the", " ", "fall", " ", "of", " ", "the", " ", "determinant", " ", 
    "with", " ", "the", " ", "size", " ", "of", " ", "the", " ", 
    RowBox[{"matrix", ".", " ", "Generically"}], " ", "we", " ", "find", 
    "\[IndentingNewLine]", 
    RowBox[{"Det", "[", "m", "]"}], " ", "grows", " ", "as", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"m", "^", "p"}], "]"}], " ", "where", " ", "p"}], ">", 
   RowBox[{
   "1.", "\[IndentingNewLine]", "\[IndentingNewLine]", "Because", " ", "of", 
    " ", "the", " ", "small", " ", "determinant", " ", "these", " ", 
    "matrices", " ", "are", " ", "hard", " ", "to", " ", "invert", " ", 
    "using", " ", "the", " ", "usual", " ", "numerical", " ", 
    RowBox[{"methods", "."}]}]}], "\[IndentingNewLine]", "*)"}]], "Input",
 Editable->False,
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.460782468829102*^9, 3.460782607227333*^9}, 
   3.460782915348385*^9, {3.460786826043015*^9, 3.460786946022351*^9}},
 FontSize->18,
 Background->RGBColor[0.5, 0, 0.5]],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"van", " ", "der", " ", "Monde", " ", "of", " ", "points", " ", 
      RowBox[{"x", "[", 
       RowBox[{"[", "j", "]"}], "]"}]}], " ", "=", " ", 
     RowBox[{"Log", "[", 
      RowBox[{"j", "+", "1"}], "]"}]}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"p", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "j", ",", "k", ",", "m", ",", "n", ",", "prec", ",", " ", "z", ",", 
           "eig"}], "}"}], ",", "\[IndentingNewLine]", " ", 
         RowBox[{
          RowBox[{"n", "=", 
           RowBox[{"2", "^", "i"}]}], ";", " ", 
          RowBox[{"prec", "=", 
           RowBox[{"Max", "[", 
            RowBox[{
             RowBox[{"n", "^", "2"}], ",", "10"}], "]"}]}], ";", 
          "\[IndentingNewLine]", " ", 
          RowBox[{"z", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"j", "+", "1"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "n"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"m", "=", 
           RowBox[{"N", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "^", "k"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "n"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"k", ",", "n"}], "}"}]}], "]"}], ",", "prec"}], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"Abs", "[", 
               RowBox[{"Log", "[", 
                RowBox[{"Abs", "[", 
                 RowBox[{"Det", "[", "m", "]"}], "]"}], "]"}], "]"}], "]"}], 
             "/", "i"}]}], "}"}]}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "6"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MatrixForm", "[", "p", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"a", "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"p", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"b", "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"p", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"Directive", "[", 
         RowBox[{
          RowBox[{"PointSize", "[", "Large", "]"}], ",", "Orange"}], 
         "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"b", ",", "a", ",", " ", 
     RowBox[{
     "PlotLabel", " ", "\[Rule]", " ", 
      "\"\<Log[Log[Det m]]/Log[Size of m]\>\""}]}], "]"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.460779853133279*^9, 3.460779951109783*^9}, {
   3.460779998597948*^9, 3.460780012977606*^9}, {3.460780127409624*^9, 
   3.460780249312382*^9}, {3.460780331238636*^9, 3.460780444267825*^9}, {
   3.460780481546315*^9, 3.460780487097424*^9}, {3.460780548839673*^9, 
   3.460780556337861*^9}, {3.460780654742658*^9, 3.460780680724491*^9}, {
   3.460781156157333*^9, 3.460781381959836*^9}, {3.460781415604342*^9, 
   3.460781548723576*^9}, {3.460781594542414*^9, 3.460781645974871*^9}, {
   3.460781695665212*^9, 3.460781880630051*^9}, {3.46078192724594*^9, 
   3.460781956245419*^9}, {3.460782283298363*^9, 3.460782304380825*^9}, {
   3.460782362952121*^9, 3.460782368532671*^9}, 3.460782444245627*^9, {
   3.460782656741118*^9, 3.460782696306062*^9}, {3.460782808717012*^9, 
   3.460782843904125*^9}, 3.460782915348499*^9, {3.460785026692185*^9, 
   3.460785203784087*^9}, {3.460785356395643*^9, 3.460785375880958*^9}, {
   3.460785506749729*^9, 3.460785514429127*^9}, {3.460785569819633*^9, 
   3.460785620407614*^9}, {3.460785728960515*^9, 3.460785740980206*^9}, {
   3.460785997341505*^9, 3.460785997557155*^9}, {3.460786338561084*^9, 
   3.460786420961814*^9}, {3.460786580171037*^9, 3.460786580850285*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"van", " ", "der", " ", "Monde", " ", "of", " ", "points", " ", 
      RowBox[{"x", "[", 
       RowBox[{"[", "j", "]"}], "]"}]}], " ", "=", " ", 
     RowBox[{"1", "-", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"j", "+", "1"}], ")"}]}]}]}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"p", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "j", ",", "k", ",", "m", ",", "n", ",", " ", "prec", ",", "z", ",", 
           "eig"}], "}"}], ",", "\[IndentingNewLine]", " ", 
         RowBox[{
          RowBox[{"n", "=", 
           RowBox[{"2", "^", "i"}]}], ";", " ", 
          RowBox[{"prec", "=", 
           RowBox[{"Max", "[", 
            RowBox[{
             RowBox[{"n", "^", "2"}], ",", "10"}], "]"}]}], ";", 
          RowBox[{"z", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"1", "-", 
              RowBox[{"1", "/", 
               RowBox[{"(", 
                RowBox[{"j", "+", "1"}], ")"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "n"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"m", "=", 
           RowBox[{"N", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "^", "k"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "n"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"k", ",", "n"}], "}"}]}], "]"}], ",", " ", "prec"}], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"Abs", "[", 
               RowBox[{"Log", "[", 
                RowBox[{"Abs", "[", 
                 RowBox[{"Det", "[", "m", "]"}], "]"}], "]"}], "]"}], "]"}], 
             "/", "i"}]}], "}"}]}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "6"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MatrixForm", "[", "p", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"a", "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"p", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"b", "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"p", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"Directive", "[", 
         RowBox[{
          RowBox[{"PointSize", "[", "Large", "]"}], ",", "Orange"}], 
         "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"b", ",", "a", ",", " ", 
     RowBox[{
     "PlotLabel", " ", "\[Rule]", " ", 
      "\"\<Log[Log[Det m]]/Log[Size of m]\>\""}]}], "]"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.460781983413787*^9, 3.460782044541659*^9}, {
   3.460782087308474*^9, 3.460782193737065*^9}, {3.460782223783372*^9, 
   3.46078226421321*^9}, {3.460782312161526*^9, 3.460782326213651*^9}, {
   3.460782372361334*^9, 3.460782375646584*^9}, 3.460782439629728*^9, {
   3.460782705665968*^9, 3.460782708927552*^9}, 3.460782858790355*^9, 
   3.460782915348593*^9, {3.460785221404486*^9, 3.460785241478754*^9}, {
   3.460785323669429*^9, 3.460785337495957*^9}, {3.460785461559486*^9, 
   3.460785463252138*^9}, {3.460785520941144*^9, 3.460785527996129*^9}, {
   3.46078562696532*^9, 3.460785638754429*^9}, {3.460785693821014*^9, 
   3.460785694320973*^9}, {3.460785759920685*^9, 3.460785760349834*^9}, {
   3.460785993424196*^9, 3.46078599362701*^9}, {3.460786037869826*^9, 
   3.460786063657848*^9}, {3.460786326058762*^9, 3.460786330198137*^9}, {
   3.460786386276191*^9, 3.46078638664198*^9}, {3.460786416705798*^9, 
   3.460786417030872*^9}, {3.460786606449632*^9, 3.460786606593894*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"van", " ", "der", " ", "Monde", " ", "of", " ", "points", " ", 
      RowBox[{"x", "[", 
       RowBox[{"[", "j", "]"}], "]"}]}], " ", "=", " ", 
     RowBox[{"j", "+", "1"}]}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"p", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "j", ",", "k", ",", "m", ",", "n", ",", " ", "prec", ",", "z", ",", 
           "eig"}], "}"}], ",", "\[IndentingNewLine]", " ", 
         RowBox[{
          RowBox[{"n", "=", 
           RowBox[{"2", "^", "i"}]}], ";", " ", 
          RowBox[{"prec", "=", 
           RowBox[{"Max", "[", 
            RowBox[{
             RowBox[{"n", "^", "2"}], ",", "10"}], "]"}]}], ";", 
          RowBox[{"z", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"j", "+", "1"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "n"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"m", "=", 
           RowBox[{"N", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"z", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "^", "k"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "n"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"k", ",", "n"}], "}"}]}], "]"}], ",", " ", "prec"}], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"Abs", "[", 
               RowBox[{"Log", "[", 
                RowBox[{"Abs", "[", 
                 RowBox[{"Det", "[", "m", "]"}], "]"}], "]"}], "]"}], "]"}], 
             "/", "i"}]}], "}"}]}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "6"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MatrixForm", "[", "p", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"a", "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"p", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"b", "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"p", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"Directive", "[", 
         RowBox[{
          RowBox[{"PointSize", "[", "Large", "]"}], ",", "Orange"}], 
         "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"b", ",", "a", ",", " ", 
     RowBox[{
     "PlotLabel", " ", "\[Rule]", " ", 
      "\"\<Log[Log[Det m]]/Log[Size of m]^2\>\""}]}], "]"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.460782341675407*^9, 3.460782382532041*^9}, 
   3.460782436361716*^9, 3.460782716148716*^9, 3.460782869520916*^9, 
   3.460782915348681*^9, {3.460785265105881*^9, 3.460785294613416*^9}, {
   3.460785542117392*^9, 3.460785560594418*^9}, {3.460786002912633*^9, 
   3.460786003144652*^9}, {3.460786079166644*^9, 3.460786097065964*^9}, {
   3.460786175962978*^9, 3.460786181633694*^9}, {3.460786244160957*^9, 
   3.460786317104958*^9}, {3.460786404714011*^9, 3.460786405311396*^9}, {
   3.46078661032401*^9, 3.460786610689757*^9}}]
}, Closed]]
},
WindowSize->{640, 573},
WindowMargins->{{Automatic, 80}, {Automatic, 25}},
ShowSelection->True,
FrontEndVersion->"6.0 for Linux x86 (32-bit) (February 7, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 1314, 25, 356, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[1907, 50, 4241, 101, 253, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[6151, 153, 4100, 101, 209, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[10254, 256, 3451, 89, 209, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Closed]]
}
]
*)

(* End of internal cache information *)
